/****************************************************
* Programa C kalba "Dvizenklio skaiciaus atvaizdavimas 7 segmentu indikatoriuje"
* Mikrovaldiklis: PIC18F14K22
* Daznis: 16MHz
*****************************************************/

/** I N C L U D E S *********************************/
#include <p18cxxx.h>

/** C O N F I G U R A T I O N ***********************/
#pragma config FOSC   = IRC		//vidinis RC rezonatorius
#pragma config WDTEN  = OFF		//Watchdog Off
#pragma config LVP    = OFF		//Low voltage program

/** Duomenys programu atmintyje *********************/
const rom unsigned char table_7_segm[] = 	//kodu lentele
{
	0x3F,		//0
	0x06,		//1
	0x5B,		//2
	0x4F,		//3
	0x66,		//4
	0x6D,		//5
	0x7D,		//6
	0x07,		//7
	0x7F,		//8
	0x6F		//9
};

#pragma code

/** F U N C T I O N S *******************************/
void delay (unsigned int ms)
{
	unsigned int i;
	while (ms--) {
		for (i = 0; i < 332; i++)
		;
	}	
}

/** M A I N *****************************************/

void main(void)
{			
	float skaicius = 0;			//kintamasis skaiciui
	char indikatorius = 0;		//kintamasis indikatoriui ijungti
	char i = 0;
	
	OSCCONbits.IRCF2 = 1;		//Vidinis RC rezonatorius
	OSCCONbits.IRCF1 = 1;		//nustatomas 16MHz
	OSCCONbits.IRCF0 = 1;

	ANSEL = 0b00000000;			//Visi MV isvadai nustatomi		
	ANSELH = 0b0000;			//kaip skaitmeniniai

	PORTA = 0;
	TRISA = 0x01;				//RA0 - iejimas
	PORTB = 0;
	TRISB = 0;
	PORTC = 0;
	TRISC = 0;					//visi PORTC isvadai - isejimai
	
	while (1)
	{
		/*
		skaicius = 23;         		// skaicius atvaizdavimui
		skaicius = skaicius+0.5;	// apvalinimui!

		skaicius = skaicius/10;
		indikatorius = 0x80;
		for (i=0; i<2; i++) {			
			LATC = table_7_segm[(int)skaicius];
			skaicius = skaicius - (int)skaicius;
			skaicius = skaicius * 10;
			LATB = indikatorius;	//ijungiamas indikatorius
			delay (3);				//indikatoriaus svietimo trukme
			LATC = 0;
			LATB = 0;				//indikatorius isjungiamas
			indikatorius = indikatorius >> 1;
		} //end for()
		*/

		LATB = 0x80;
		LATC = table_7_segm[3];
		delay (3);
		LATC = 0;
		LATB = 0;
		delay (3);
		LATB = 0x40;
		LATC = table_7_segm[2];
		delay (3);
		LATC = 0;
		LATB = 0;
		delay (3);
				
	} //end while()		
}